MICROSOFT Coding Interview | Getting Interviewed by a Microsoft Engineer

Поделиться
HTML-код
  • Опубликовано: 20 июл 2024
  • 🔴 Learn DSA - learnyard.com/courses/dsa
    Free premium articles - read.learnyard.com
    ..................................................................................
    Service Based To Google: • Video
    🔴 Free Gifts from Crio www.crio.do/redeem/f062a88/
    🔴 Don't Click this! bit.ly/3GBAV7f
    🔴Watch the complete Linked List Series • Linked List Series
    🔴Placement Preparation Roadmap • Roadmaps for Placement
    🔴My contact details
    Instagram :- / frazmohammad
    Connect with me on LinkedIn :- / mohammad-f-bb4886157
    Telegram Group t.me/LeadCoding
    RUclips:
    / kushalvijay
    Instagram:
    / kushal_vijay_
    Linkedin:
    / kushalvijay
    Twitter:
    / kushalvijay_
    The video contains following parts-
    0:00-0:40 - Intro
    0:41-1:35 - Question 1
    1:36-4:01 - Question 1 discussion
    4:02-05:17 - Crio Sponsorship
    5:18-13:21 - Question 1 discussion
    13:22-16:58 - Question 1 Code
    17:00-17:46 - Question 2
    17:47-25:25 - Question 2 discussion
    25:26-35:56 - Question 2 code
    35:57-36:20- Closing Notes
    Hi, I am Fraz.
    I am Software Engineer working at Curefit and I love teaching.
    This is my Channel where I upload content related to Interviews and my personal experiences.
    ✨ Hashtags ✨
    #SoftwareEngineer #FAANGM #FAANG #DTU #engineering #internship #college #DSA #Freshers

Комментарии • 204

  • @arishsheikh3000
    @arishsheikh3000 2 года назад +195

    It should be row++ instead of col++

    • @mohammadfraz
      @mohammadfraz  2 года назад +44

      Yes thanks for the correction

    • @shanmukha599
      @shanmukha599 2 года назад +5

      Yes same doubt raised to me thank you👍

    • @ankushmudgil9352
      @ankushmudgil9352 2 года назад +1

      Yes i also found that error

    • @singiri697
      @singiri697 2 года назад +1

      Moving backwards increments the rows,?

    • @lokeshborole8997
      @lokeshborole8997 Год назад

      ​@@ankushmudgil9352 so smrt😅

  • @akshatmahajan2692
    @akshatmahajan2692 2 года назад +15

    really helpful more similar videos would definitely boost the confidence before campus placements

  • @subhamshaw7755
    @subhamshaw7755 5 месяцев назад +2

    we can also use a base case if(targ < a[0][0] || targ > a[n-1][n-1]) return false;

  • @codencode5546
    @codencode5546 2 года назад +52

    Sir first of all thanks to you and Kushal Sir to feel the Enviroment of a Real Interview and I can solve all the 2 Questions so I'm Happy that my Efforts are worth it!!

  • @manojsv8252
    @manojsv8252 Год назад +6

    I think we can reduce the for loop iterations a bit in case we have many numbers by having a condition "nums[i]

  • @devanshmesson2777
    @devanshmesson2777 2 года назад +24

    Much needed videos like this!
    Just want to thank you for this!
    Telling the approach in an interview is a skill, thank you for guiding us about how to give an interview!

    • @mohammadfraz
      @mohammadfraz  2 года назад +3

      Thanks a lot for appreciating ☺️, hope it helps

  • @artemsydorchuk4711
    @artemsydorchuk4711 Год назад +2

    For the first problem, is the solution with binary search better?
    We can start from the middle in the mattrix, like from the centre of the quadrate and based on the value get rid from all left bottom values or right upper. Than define the middle of new quadrate and repeat a procedure. Time complexty in this case will be O(log(n*m)) which is much better.

  • @subhamengine1143
    @subhamengine1143 2 года назад +1

    Just heard your approach and tried to code myself on LC, and it was correct in the first attempt.

  • @saswatsenapati7870
    @saswatsenapati7870 11 месяцев назад

    Great video of the mock.
    Just one highlight point, clarifying questions can be better, for example in triplet question you could have asked do i have to return all the triplets or just one, or what return value is expected the triplet values or its indexes or just a boolean.

  • @ankursharma6084
    @ankursharma6084 2 года назад +58

    Nicely explained , both problems are from this month's leetcode daily challange 😃😃

    • @mohammadfraz
      @mohammadfraz  2 года назад +5

      Thanks ☺️

    • @learnenglish699
      @learnenglish699 2 года назад +2

      hello ankur sharma bhai ek baat puchne thee pls are u there?

  • @aakashshelake
    @aakashshelake 2 месяца назад +2

    You can treat whole matrix as 1d array
    Where low = 0, high = n * m - 1
    And do binary search
    We can find row and col like
    Mid/m , mid%m res.

  • @ahmedbahri5115
    @ahmedbahri5115 Год назад +4

    for the first question there is a faster approach , you have to use the sorting more efficiently, there is this O(log n+m ) solution :
    class Solution:
    def searchMatrix(self, matrix: List[List[int]], target: int) -> bool:
    right = len(matrix[0]) -1
    bottom = len(matrix)-1
    top ,left=0,0
    def searchHelper(matrix,top,bottom,left,right,target,visited):
    if top > bottom or left > right:
    return False
    mid1=(top+bottom)//2
    mid2=(left+right)//2
    if (mid1,mid2) in visited :
    return False
    visited.append((mid1,mid2))
    if matrix[mid1][mid2] == target :
    return True
    if matrix[mid1][mid2]>target:
    return searchHelper(matrix,top,bottom,left,mid2-1,target,visited) or searchHelper(matrix,top,mid1-1,left,right,target,visited)
    else:
    return searchHelper(matrix,top,bottom,mid2+1,right,target,visited) or searchHelper(matrix,mid1+1,bottom,left,right,target,visited)

    return searchHelper(matrix,top,bottom,left,right,target,[])

    • @AjaySingh-us1ku
      @AjaySingh-us1ku 5 месяцев назад

      using recursion is not always a good thing, but yes it can be optimized to 1 more layer using iterative approach.

  • @dollyyadav3251
    @dollyyadav3251 2 года назад +8

    keep doing good work👏👏like each & every video of yours. Amazing content, u r providing a great guidance to each one of us😃

  • @rishabhraj9802
    @rishabhraj9802 2 года назад +5

    10:40 @fraz the reason you are giving that you will be able to move in two directions is a assertion not a reason. Reason is you can stand either on four corners or in between the array, inbetween you will have conflicting choices as incrementing row or col will result in bigger values and vice versa but when you start from top right or bottom left you have two non conflicting choices, if you go left you decrease, down increase and vice versa foe other situation

    • @mohammadfraz
      @mohammadfraz  2 года назад +2

      Exactly 😊.
      This is the reason why we can only start from top right or bottom left.

    • @rishabhraj9802
      @rishabhraj9802 2 года назад

      @@mohammadfraz The way you took it man hats off, shows why you have so many submissions on leetcode.

  • @stuart3565
    @stuart3565 Год назад +3

    i really liked this mock interview please upload more video like this it helps to prepare
    bhaiya can i crack the google and microsoft beacuse recently i have started learning dsa from scracth and i am in mid of the 5th sem but i am facing problem while solving questions in optimized way most of the times i watch the solution

  • @piyushmathpal4244
    @piyushmathpal4244 2 года назад

    this playlist is best
    Please continue mock interview series

  • @244_debajitdatta
    @244_debajitdatta 2 года назад +2

    Max possible min time complexity is
    (Logm+logn)
    If we modify the binary search

  • @pjagannadham2540
    @pjagannadham2540 Год назад

    fraz bhaiyya oo first question ka approach is really super and it's easy to understand keep sharing this knowledge bhaiyya

  • @apurbaghosh5540
    @apurbaghosh5540 2 года назад +5

    1st ques is asked in my one of interview in my placement session 😍😍

  • @tomaraditya9487
    @tomaraditya9487 2 года назад +2

    Wow bhaiyaa great video....
    The elements to be unique was the first thing clicked in my mind😇

  • @LalitSingh-gu3dt
    @LalitSingh-gu3dt 2 года назад +3

    inplace of col++ will be col- - And similarly inplace of row-- will be row++

  • @ritwikshivam1203
    @ritwikshivam1203 Год назад

    In the first question, it should be col-=1 and row+=1, coz we are coming down to next row if target>current element else 1 col backwards?
    Amazing video btw

  • @KushalVijay
    @KushalVijay 2 года назад +23

    Great conversation with you Fraz, Excited for our next mock interview on my channel. ❤️🔥

    • @mohammadfraz
      @mohammadfraz  2 года назад +4

      Yess 🔥 , excited for your turn.

    • @sureshdhakad9854
      @sureshdhakad9854 2 года назад +5

      You could have given your detailed feedback at the end of the interview then only it will be helpful for the people who are preparing for interviews.
      Like always ask clarifying question before start discussion the solution.
      I am also taking interviews at my org and find that candidate doesn't ask clarifying questions and also they just jump on coding and doesn't discuss the solution before writing the code.
      These are my expectations as an interviewer:
      1. Candidate should ask clarifying question before discussing the approach to solve the problem.
      2. Candidate should confirm with the interviewer if the approach looks good then only start the coding.
      3. Candidate should think and code loudly so that if he/she get stuck then interviewer can give some hint.
      4. Always try to write optimized code.
      5. Never give up in an interview and seek hint/help if get stuck somewhere. don't seek more than 2 hints.
      6. Consider edge cases and dry run the code with at least 2-3 test cases.

  • @nandharamya9612
    @nandharamya9612 Год назад

    If all elements in Matrix is unique then we no need to bother row and column and straightaway we can do binary search tree using a single pointer right. Am I right on this understanding?

  • @kaustubhshrivastava3169
    @kaustubhshrivastava3169 2 года назад +2

    can you get some more medium level questions next time wich are some what harder to solve so that we can get a gist of how to handle the pressure in those situation where we are not getting to the optimal solution btw nice video😀

    • @harshsrivastava2324
      @harshsrivastava2324 Год назад

      Interviewer questions bnata nahi hai kahi se utha ke hi lata hai except Google

  • @greatest5902
    @greatest5902 2 года назад

    Need more videos in similar format!!

  • @shatadal_das
    @shatadal_das 9 месяцев назад

    Sir, I solved the first question in O(log (n*m)) complexity by applying Binary search in the last column and Binary Search in the row in which the target may be present.

  • @siddhantkhare2775
    @siddhantkhare2775 2 года назад +63

    Microsoft Engineer using GOOGLE Docs:

    • @shyam_mahadevan
      @shyam_mahadevan 8 месяцев назад +1

      Document is not important or any paper its about the concept which is required

  • @AJAYKUMAR-pj3zq
    @AJAYKUMAR-pj3zq 2 года назад +1

    It's great sir please upload this types of video

  • @surgeonofdeath8199
    @surgeonofdeath8199 2 года назад

    In the first question we can apply that 2-d array binary search as well using division and mod as well ..
    Won't that be actually better approach if it is sorted row wise and Column wise both

    • @BROOKnim
      @BROOKnim Год назад +1

      hmm it won't work without this constraint "every element on one row is greater than the elements on previous rows "
      If this constraint was given , we can consider the 2d array as a 1d array and Bo binary search

    • @gatecsemaster
      @gatecsemaster Год назад

      this apply when you have the whole matrix is sorted .

  • @dynamichussain1770
    @dynamichussain1770 2 года назад +1

    bhaiya for the second question in the 3rd while loop (nums[e]==nums[e+1])it should be e-- instead of e++.

  • @SL4UGHT3R
    @SL4UGHT3R Год назад

    In first question else statement says row - - which means you are going a row above but that doesn't make any sense. On the other hand where are you checking that target is present or not in that row if column[lastElement]>target.

  • @ShinAkuma
    @ShinAkuma Год назад

    In the first question, why not start at the middle element ?
    The travel distance will always be shortest no matter where your target element lies on the matrix. If you start at the corner and the element lies at the end of the diagonal, you've spent 2X more time than you would have if you started at the middle.

  • @abdussamad0347
    @abdussamad0347 2 года назад +17

    I recently practiced both the questions on leetcode. You did it very well. I think in the last question . The duplicates for first loop i.e for i should be the check of arr[i] and arr[i+1]. The for loop itself will handle the last increment.

    • @mohammadfraz
      @mohammadfraz  2 года назад +3

      Yes i was doing about to the same after discussing space and time but then we concluded it

    • @poorpanda9033
      @poorpanda9033 8 месяцев назад

      Can you send the leetcode link for these questions ?

  • @lolwemen
    @lolwemen Год назад

    ques 1 coptimized approach was actually using binary search, worst case the given by fraz in actually N2 if element is near right corner

  • @divine5863
    @divine5863 2 года назад +4

    We need more videos like this

  • @brahmanandakabi8796
    @brahmanandakabi8796 Год назад

    Thank you bro for this type of content

  • @developerDebanjan
    @developerDebanjan 2 года назад +1

    If only the actual level of the questions would have been like these..

  • @roydebraj2188
    @roydebraj2188 Год назад

    its been only a week now of me learning java and i was able to ans the first question i have learnt till arrays and wasnt aware of the concept of binary search i am sure i will learn it in the future. i am writing this message because i am just happy happy hahaha

  • @yashnegi9473
    @yashnegi9473 Год назад

    thank you. It is my dream company to work for. Really appreciate all your efforts sir.

  • @codenchill732
    @codenchill732 2 года назад +2

    Keep doing more such interviews

  • @luckyloops2714
    @luckyloops2714 2 года назад

    We can use hashmap with I and j variables sliding through all of them

  • @kedarkulkarni9464
    @kedarkulkarni9464 2 года назад

    I was asked the exact same 1st question for my Microsoft interview :)

  • @gauravgautam5963
    @gauravgautam5963 2 года назад

    When we will expect the interview to be taken by you on Kushal vijay's channel that will be to awesome

  • @livingwiththedivinesoul8335
    @livingwiththedivinesoul8335 Год назад +1

    When was it said that the array is going to be sorted in the second question?

  • @gkthecoder9589
    @gkthecoder9589 Год назад

    can we use a membership check right..!, Weather the element is present or not.

  • @PraveenKumar-nu9wk
    @PraveenKumar-nu9wk Год назад

    Bhaiya in the first problem ie. Find element in sorted matrix ,row and col should be interchanged.

  • @AnkitMishra-ss7mw
    @AnkitMishra-ss7mw 6 месяцев назад

    Please start with an introduction

  • @dsa0decoded
    @dsa0decoded 4 месяца назад

    are these to boost confidence or microsoft really ask such easy questions ?

  • @technicalrafik7034
    @technicalrafik7034 2 года назад

    You are doing great work bhaiya Allah Bless You 💯

  • @phoneix24886
    @phoneix24886 2 года назад

    The first one could be done in log(m*n). nlog(m) is not optimal.

  • @ganapathi2531
    @ganapathi2531 2 года назад

    This was good, just a suggestion , it would be good if the input and output is given in docs before explaining the question by the interviewer

    • @mohammadfraz
      @mohammadfraz  2 года назад

      Sometimes interviews don't give input or output. But we can always get it clarified

    • @Labrador_Stunts
      @Labrador_Stunts Год назад

      @@mohammadfraz hi Fraz . Iam new to this .. what is these questions. What kind of coding is this .. is this realated to DSA?

  • @prettysmart3732
    @prettysmart3732 2 года назад +1

    Faraz Sir ye live kro phir bahut acha hoga btw it was great thanks a lot

  • @ahmedmukhtar6961
    @ahmedmukhtar6961 2 года назад

    I didn't knew they make you write code in microsoft word? i thought we could use normal IDEs.

  • @skmdmobinulislam9597
    @skmdmobinulislam9597 2 года назад

    Do we have to use google docs in actual interview also?

  • @TheZorboidOrbb
    @TheZorboidOrbb Год назад +2

    Good video but even before starting with your brute force approach, you should have got some clarifications out of the way. Like
    1. Are all elements positive?
    2. Whole numbers?
    3. Are all elements unique?
    Approaching a solution without getting all the cases and conditions is a strict no. Since this is a mock, you should be very careful in what you teach others.

  • @Vibedecoded
    @Vibedecoded Год назад

    Search in a 2d matrix, 3 Sum (leetcode question)

  • @garigantibhanuvenkatasaikr3164
    @garigantibhanuvenkatasaikr3164 2 года назад

    very informative

  • @razataggarwal7365
    @razataggarwal7365 10 месяцев назад

    Question 1 can be solved with O(M+N) TC and constant space.

  • @jayeshnayee6735
    @jayeshnayee6735 2 года назад

    Bhaiya online coding platform like gfg,codeshaf, mein code kese likhe, start, end kese kare kuch pata hai nahi chalta, vs code me code likhu too kuch error nahi ati please help me ans please

    • @mohammadfraz
      @mohammadfraz  2 года назад

      Easy questions practice karo, usse help milegi kafi

  • @KalpitSharma
    @KalpitSharma Год назад

    Easy Question puchha tumne , interview me humko tough ques q aatay hai :( But it really helped a lot to understand how interview should be.

  • @saulgoodman6710
    @saulgoodman6710 10 месяцев назад

    Wait hows the first q solution correct, he didn't even perform binary search right?

  • @AmitSharma-yi9dr
    @AmitSharma-yi9dr 2 года назад

    does top companies like microsoft accept candidates with extended education..as in b.tech completed in 6 yrs .

  • @newvideo4033
    @newvideo4033 2 года назад

    Plz bhaiya more video upload karo

  • @subhamdasgupta3848
    @subhamdasgupta3848 Год назад

    My one liner pythonic solution for question 2,
    [i for i in list(itertools.combinations(list(set(x)), 3)) if sum(list(i)) == k]
    P.S: This solution is only meant for fun.

  • @meetshah31
    @meetshah31 11 месяцев назад

    the 1st question is so easy i just solved it in leetcode if i were in the interview im like boom

  • @Manoj_Jadhav.12
    @Manoj_Jadhav.12 Год назад +2

    Man that 3rd approach of first question was 🔥🔥

  • @ashishverma-gw7cc
    @ashishverma-gw7cc 2 года назад

    3rd approach will be like,
    Apply BS on 1st column, in log(#col) time we'll have the row where we can expect target element. Then in that row again apply BS to see if element is present or not, log(#col).
    total TC = log(#col) + log(#row) +O(1)

    • @BROOKnim
      @BROOKnim Год назад

      If you see the question correctly this won't work
      Consider the matrix like this
      [1,3,7]
      [2,4,6]
      [8,9,10]
      And let target be 7
      Here if you apply bs on first column, you'll get the row where ans should be present is third not first ..
      Your approch will be correct if there was this constraint " all the elements on one row is greater than elements from before rows"

  • @487_sahilrout3
    @487_sahilrout3 2 года назад +1

    Wow agar sachmein is level ka aata hoga microsoft ke interviews pe tab to mera mast se nikal jyega knew both the questions 😄

    • @mohammadfraz
      @mohammadfraz  2 года назад +2

      Great 🔥 all the best Sahil

    • @sahilrout4745
      @sahilrout4745 2 года назад +2

      @@mohammadfraz Thnx bhaiya 🙌 internship season shuru hone wala hai college pe july se need this all the best

  • @aamirhannan890
    @aamirhannan890 Год назад

    Ohh bahi, ye question maine aaj hi kia LeetCode pe!.. logn + logm me ban jaayegi ye binary search se...

  • @shubamgoswami
    @shubamgoswami 2 года назад

    ver informative

  • @NOTOni
    @NOTOni 2 года назад

    hi
    you are having a great day TILL NOW ........

  • @PIYUSH-lz1zq
    @PIYUSH-lz1zq 2 года назад

    Yeee sahi tha !

  • @AnkurVashishtha01
    @AnkurVashishtha01 Год назад +1

    Good to see Virat Kohli solving problem. haha jokes aside, amazing content. subbed!

  • @garigantibhanuvenkatasaikr3164
    @garigantibhanuvenkatasaikr3164 2 года назад

    very interesting

  • @someshsahu4638
    @someshsahu4638 Год назад +1

    Nice replica 👍🏼

  • @dsadaddy8403
    @dsadaddy8403 Год назад

    you should have got some dp in the house!

  • @funnygamer4620
    @funnygamer4620 Год назад

    It should be row++ and else col--

  • @TheRiddLer870
    @TheRiddLer870 2 года назад

    when should i solve your sheet after completely learning dsa or while learning
    it pls reply

  • @laluchouhan9163
    @laluchouhan9163 Год назад

    make a video who take a job from non tech branch

  • @bicky_singhkushwaha228
    @bicky_singhkushwaha228 2 года назад

    col-- and row++ instead of col++ and row--

  • @vishalnama7257
    @vishalnama7257 2 года назад

    Which language is that code you wrote

  • @fardeenshaikh6434
    @fardeenshaikh6434 2 года назад

    wow bhaiya bhut accha experience diya like real interview

  • @pyatlasaikrishnapyatla5676
    @pyatlasaikrishnapyatla5676 2 года назад

    bayya please suggest me I have less cgpa in msc ..... please tell me which company may i eligible

  • @sanskrutikanse-fj2rc
    @sanskrutikanse-fj2rc Год назад

    Hii fraz aapko kitne coding question puche the product based company ke interview mei.can u tell

  • @vishakhas1867
    @vishakhas1867 2 года назад

    Its strange in all mock interview first question asked is of matrix, the same one..

  • @ayajakhtaransari7801
    @ayajakhtaransari7801 2 года назад

    Fraz bhaiya plzz bring some podcasts videos also

  • @notrahul9572
    @notrahul9572 27 дней назад

    First is not optimal log(m*n) is optimal

  • @dhananjaysahu9076
    @dhananjaysahu9076 2 года назад +1

    I don't think they will ask these well known questions in off campus interviews

  • @PROTECHRAHUL
    @PROTECHRAHUL 2 года назад +1

    Bhaiyaa i was able to solve first question 🙂

  • @kartikeytandon7769
    @kartikeytandon7769 Год назад

    I was able to solve both the questions, can anybody tell me that are real Interview questions like this only?

  • @SachinRao435
    @SachinRao435 Год назад

    But why you not use a DP in Second Question

  • @iakash017
    @iakash017 2 года назад

    thank you so much bhaiya

  • @himanshugupta5812
    @himanshugupta5812 2 года назад +1

    pls increase your sound your sound was less and interviewer sound was good

    • @mohammadfraz
      @mohammadfraz  2 года назад

      It's just because our audio was recorded at his side

  • @Salesforce_skool
    @Salesforce_skool Год назад

    It should be col-- and row ++

    • @jude4736
      @jude4736 Год назад

      Yes ur right , good observation

  • @mohammadkaifdevalapur
    @mohammadkaifdevalapur Год назад

    Bhaiya i am stuck in dsa i not understanding how to complete dsa in 1 month

  • @mathematics6199
    @mathematics6199 2 года назад +1

    1st question was good

  • @kartikkk4583
    @kartikkk4583 2 года назад

    ye questions to aapke liye easy honge FRAZ bhaia

  • @madetolaugh3476
    @madetolaugh3476 2 года назад

    Interview mein leetcode wagera mein nhi hota kya coding round ?

  • @avinashv7154
    @avinashv7154 Год назад

    I completed btec in ECE with 7cgpa (63%). Can i apply amazon CSA role
    I had seen your video on this topic and it's my aim to get a job in CSA bro please reply

    • @mikehawk9762
      @mikehawk9762 Год назад

      i am also a fresher in ece branch?how much do we learn related to cse there?pls Reply